; PutAside by justice
; to enable updating, please install DcuHelper via 
; http://www.donationcoder.com/Forums/bb/index.php?topic=9607 in a subfolder of this script
; called dcuhelper

; general configuration
#NoEnv ; Recommended for performance and compatibility with future AutoHotkey releases.
SendMode Input ; Recommended for new scripts due to its superior speed and reliability.
#SingleInstance,Force
SetWinDelay,0
Dir = %A_AppData%\PutAside
IniFile = settings.ini
FileCreateDir, %Dir%
SetWorkingDir, %Dir%
version = 1.11

; setting variables
ExclusionList =
PutAsideHK = +ScrollLock
CycleHK = ScrollLock
Processes =
IDs =
maxItems = 
PutAsideEnabled =
this_windowcycle =

; main
Gosub,READINI
Gosub,RegisterAutoUpdate
Gosub,SetHotKeys
Gosub,IndexWindows
OnExit, QUIT
GoSub, Standby

IndexWindows:
	; acquire a list of processes to work with
	GoSub, PrettyHotkeys
	Traytip,PutAside, %PutAsideHKmsg%`t Put aside / restore windows.`n%CycleHKmsg%`t Cycle through hidden windows.
	WinGet, id, list,,, Program Manager ; get list of all foreground ids
	Loop, %id%
	{
	  this_id := id%A_Index%
		WinGet, this_process, ProcessName, ahk_id %this_id%
		if NOT this_process ;exclude emptiness
			continue
		WinGetTitle, this_title, ahk_id %this_id%
		if NOT this_title ;exclude start menu and empty processes
				continue
		StringGetPos, pos, ExclusionList, %this_process%
		i +=1
		Processes%i% := this_process
		IDs%i% := this_id
	}
	id = 
	maxItems := i
	GoSub, TRAYMENU
return

PrettyHotkeys:
	; Translate hotkey modifiers to proper English
	StringReplace, PutAsideHKmsg, PutAsideHK, +, Shift-, All
	StringReplace, PutAsideHKmsg, PutAsideHKmsg, #, Win-, All
	StringReplace, PutAsideHKmsg, PutAsideHKmsg, !, Alt-, All
	StringReplace, PutAsideHKmsg, PutAsideHKmsg, ^, Control-, All

	StringReplace, CycleHKmsg, CycleHK, +, Shift-, All
	StringReplace, CycleHKmsg, CycleHKmsg, #, Win-, All
	StringReplace, CycleHKmsg, CycleHKmsg, !, Alt-, All
	StringReplace, CycleHKmsg, CycleHKmsg, ^, Control-, All
return

SetHotKeys:
	if PutAsideHK
		Hotkey,%PutAsideHK%,PutAside, ON
	if CycleHK
		Hotkey,%CycleHK%,CycleWindows, ON
return

CheckUpdate:
	; check for updates. 
	; When no updates are found nothing is displayed.
	; make sure the dcuhelper.exe is in a subdirectory of this script's location.
	cmdParams = -ri
	cmdParams2 = . -show -nothingexit
	GoSub, DcUpdateHelper
return

RegisterAutoUpdate:
	; Register with DcUpdater. 
	; When no updates are found nothing is displayed.
	; make sure the dcuhelper.exe is in a subdirectory of this script's location.
	cmdParams = -r
	cmdParams2 = . -shownew -nothingexit
	GoSub, DcUpdateHelper
return

DcUpdateHelper:
	uniqueID = svd-putaside
	dcuHelperDir = %A_ScriptDir%\dcuhelper
	IfExist, %dcuHelperDir%\dcuhelper.exe
	{
		OutputDebug, %A_Now%: %dcuHelperDir%\dcuhelper.exe %cmdParams% "%uniqueID%" "%A_ScriptDir%" %cmdParams2%
		Run, %dcuHelperDir%\dcuhelper.exe %cmdParams% "%uniqueID%" "%A_ScriptDir%" %cmdParams2%,,Hide
	}
return




READINI:
	; Read the stored settings
	IfNotExist, %IniFile% 
		GoSub, WRITEINI
	IniRead, ExclusionList, %IniFile%,ExclusionList, list,%ExclusionList%
	IniRead, PutAsideHK, %IniFile%,Hotkeys, PutAsideHK,%PutAsideHK%
	IniRead, CycleHK, %IniFile%,Hotkeys, CycleHK,%CycleHK%
return

WRITEINI:
	; Store settings
	IniWrite, %ExclusionList%, %IniFile%, ExclusionList, list
	IniWrite, %PutAsideHK%, %IniFile%,Hotkeys, PutAsideHK
	IniWrite, %CycleHK%, %IniFile%,Hotkeys, CycleHK
return


TRAYMENU:
	Menu,Tray,NoStandard 
	Menu,Tray,DeleteAll 
	If maxItems ; if windows have been indexed
	{
		Loop, %maxItems% ; add checkboxes for every window
		{
			this_process := Processes%A_Index%
			Menu, ToggleStatus, add, %this_process%,ToggleStatus
			StringGetPos, pos, ExclusionList, %this_process%
			if NOT ErrorLevel
				Menu, ToggleStatus, Uncheck, %this_process%
			else
				Menu, ToggleStatus, Check, %this_process%			
		}
		Menu, tray, add, &Include, :ToggleStatus
	}
	Menu,Tray,Add,
	If PutAsideEnabled ; if windows are hidden
		Menu,Tray,Add,Restore windows,PutAside
	Else
		Menu,Tray,Add,Hide windows,PutAside
	Menu,Tray,Add,
	Menu,Tray,Add,&Check for Updates...,CheckUpdate
	Menu,Tray,Add,&Preferences,SETTINGS
	Menu,Tray,Add,
	Menu,Tray,Add,&About,ABOUT
	Menu,Tray,Add,&Online Help..,ONLINE
	Menu,Tray,Add,
	Menu,Tray,Add,&Exit,QUIT
Return

ABOUT:
	; make sure the hotkeys are translated
	GoSub,PrettyHotkeys
	Msgbox, PutAside %version% by justice <justice@amasan.co.uk>`n`n`t%PutAsideHKmsg%`t Put aside / restore windows.`n`t%CycleHKmsg%`t`t Cycle through hidden windows.`n`tExclude processes using the tray menu.`n`n Thanks to AndyM, cemole, Grorgy, lanux128,  and the rest of DonationCoder.com for feedback and testing!
return

ONLINE:
	Run,http://www.donationcoder.com/Forums/bb/index.php?topic=8626
return

QUIT:
	GoSub, ShowWindows ; before exiting restore original situation
ExitApp

ToggleStatus:
	Menu,ToggleStatus,ToggleCheck,%A_ThisMenuItem%
	StringGetPos, pos, ExclusionList, %A_ThisMenuItem%
	if NOT ErrorLevel ; found
			StringReplace, ExclusionList, ExclusionList, %A_ThisMenuItem%`,,,
	else
			ExclusionList = %ExclusionList%%A_ThisMenuItem%`,
	
	Gosub, WRITEINI
Return


CycleWindows:
	If NOT PutAsideEnabled ;don't do anything
		return
	
	;hide last shown enabled window IF ENABLED
	current_id := IDs%this_windowcycle%
	StringGetPos, pos, ExclusionList, %this_process%
	If ErrorLevel ; not found in exclusion list
	{
		WinHide, ahk_id %current_id% ;hide previously opened window
	}
	If this_windowcycle = %maxItems%
			this_windowcycle = 0 ;cycle through windows from beginning
	this_windowcycle++



	;show next window
	Loop, %maxItems%
	{
		this_id := IDs%this_windowcycle%
		this_process := Processes%this_windowcycle%
		StringGetPos, pos, ExclusionList, %this_process%
		If NOT ErrorLevel ; found in exclusion list
		{
			If this_windowcycle = %maxItems%
				this_windowcycle = 0 ;cycle through windows from beginning
			this_windowcycle++	
			Continue
		}
		else
		{
			Traytip, PutAside, %this_windowcycle% - Restoring %this_process%
			WinShow, ahk_id %this_id%
			break
		}
	}
	WinActivate, ahk_id %this_id%
return

PutAside:
	If PutAsideEnabled
	{
		PutAsideEnabled =
		GoSub, ShowWindows
	}
	Else
	{
		PutAsideEnabled = true
		GoSub, HideWindows
	}
return

ShowWindows:
	; restore original situation
	Loop, %maxItems% ;show all hidden windows
	{
		next_id := IDs%A_Index%
		WinShow, ahk_id %next_id%
	}
	WinActivate
	GoSub, TRAYMENU
return

HideWindows:
	Traytip,PutAside, Putting aside windows..`nUse ScrollLock to cycle through them.
	WinGet, id, list,,, Program Manager ; get list of all foreground ps
	i= 0
	Loop, %id%
	{
	  this_id := id%A_Index%
		WinGet, this_process, ProcessName, ahk_id %this_id%
		if NOT this_process ;exclude emptiness
			continue
		WinGetTitle, this_title, ahk_id %this_id%
		if NOT this_title ;exclude start menu and empty processes
				continue
		StringGetPos, pos, ExclusionList, %this_process%
		If ErrorLevel ; not found in exclusion list
			WinHide, ahk_id %this_id%
			
		i +=1
		Processes%i% := this_process
		IDs%i% := this_id
		
	}
	id =
	maxItems := i
	GoSub, TRAYMENU
return

SETTINGS:
	Hotkey,%PutAsideHK%,Off
	Hotkey,%CycleHK%,Off
  	Gui, Destroy	
	Gui, Add, Text, x12 y12 w100 h23 , PutAside hotkey:
	Gui, Add, Hotkey, x132 y12 w170 h23 vPutAsideHK , %PutAsideHK%  
	Gui, Add, Button, x202 y87 w100 h23 GSETTINGSOK Default,&OK
	Gui, Add, Button, x92 y87 w100 h23 GSETTINGSCANCEL,&Cancel
	Gui, Add, Hotkey, x132 y45 w170 h23 vCycleHK , %CycleHK%   
	Gui, Add, Text, x12 y45 w100 h30 , Cycle hotkey:
	Gui, Show, x127 y87 h120 w320, PutAside Preferences
Return

GuiClose:
return


SETTINGSOK:
	Gui,Submit
	GoSub,SetHotKeys
	GoSub,WRITEINI
return

SETTINGSCANCEL:
	Gui,Destroy
return


Standby: